library ieee;
use ieee.std_logic_1164.all;

entity CompteurDecadeReversible is
   port (ASCDESC, Horl: in std_logic; Q0, Q1, Q2, Q3: buffer std_logic);
end entity CompteurDecadeReversible;

architecture FonctionLogique of CompteurDecadeReversible is
component BascJK is
   port (J, K, Horl: in std_logic; Q: buffer std_logic);
end component BascJK;

function AscendantDescendant(A, B, C, D: in std_logic)
   return std_logic is
begin
   return((A and B) or (C and D));
end function AscendantDescendant;

signal J1Asc, J1Desc, J1, J2, J3: std_logic;

begin
   J1Asc <= ASCDESC and Q0; J1Desc <= not ASCDESC and not Q0;
   AscDesc1: J1 <= AscendantDescendant (ASCDESC, Q0, not ASCDESC, not Q0);
   AscDesc2: J2 <= AscendantDescendant (J1Asc, Q1, J1Desc, not Q1);
   AscDesc3: J3 <= AscendantDescendant (J1Asc and Q1, Q2, J1Desc and not Q1, not Q2);
   BASC0: BascJK port map (J => '1', K => '1', Horl => Horl, Q => Q0);
   BASC1: BascJK port map (J => J1, K => J1, Horl => Horl, Q => Q1);
   BASC2: BascJK port map (J => J2, K => J2, Horl => Horl, Q => Q2);
   BASC3: BascJK port map (J => J3, K => J3, Horl => Horl, Q => Q3);
end architecture FonctionLogique;