library ieee;
use ieee.std_logic_1164.all;

entity ASCENSEUR is
   port (CodeAppel, CodePanneau: in std_logic_vector (2 downto 0);
      Appel, Requete, Capteur, Horl: in std_logic;
      MONTE, DESCEND, ARRETOUVRE, FERME: inout std_logic;
      a, b, c, d, e, f, g: out std_logic);
end entity ASCENSEUR;

architecture FonctionLogique of ASCENSEUR is

component COMPTEURETAGE is
   port (MONTE, DESCEND, Capteur: in std_logic;
      CODEETAGE: out std_logic_vector (2 downto 0));
end component COMPTEURETAGE;

component COMPARAPPELETAGE is
   port (AppelCodeEtage, CompteCodeEtage: in std_logic_vector (2 downto 0);
      MONTE, DESCEND, ARRET : inout std_logic);
end component COMPARAPPELETAGE;

component REGISTRECODE is
   port (Horl: in std_logic;
      EntreeCodeEtage: in std_logic_vector (0 to 2);
      SortieCodeEtage: out std_logic_vector (0 to 2));
end component REGISTRECODE;

component Temporisation is
   port (Validation, Horl: in std_logic;
      InitCompt: in integer range 0 to 1023;
      Qsor: inout std_logic);
end component Temporisation;

component SeptSegments is
   port (a, b, c, d, e, f, g: out std_logic;
      H0, H1, H2: inout std_logic);
end component SeptSegments;

component BasculeJK
   port (J, K, Horl: in std_logic;
      Q: out std_logic);
end component BasculeJK;

-- Dfinitions des signaux utiliss pour interconnecter les composants et les signaux de contrle de sortie

signal COMPTETAGE, APPELETAGE, ETAGEENTR: std_logic_vector (0 to 2);
signal RDC: std_logic;
begin
   RDC <= '0';
   process (Appel, Requete, CodeAppel, CodePanneau, ETAGEENTR) -- Slectionne le code dappel de ltage ou du panneau de lascenseur en fonction de APPEL/REQUETE
   begin 
      if (Appel = '1' and Requete = '0') then
ETAGEENTR <= CodeAppel; -- Si APPEL est valid, le code des boutons dappel sur ltage sont slectionns
      elsif (Requete = '1' and Appel = '0') then
ETAGEENTR <= CodePanneau; -- Si APPEL nest pas valid, le code des boutons dans la cage dascenseur sont slectionns
      end if; 
   end process;

-- Instanciations des composants

REGCODE: REGISTRECODE port map (Horl => (Appel or Requete), EntreeCodeEtage => ETAGEENTR, SortieCodeEtage => APPELETAGE);
COMPAPPETG: COMPARAPPELETAGE port map (AppelCodeEtage => APPELETAGE, 
CompteCodeEtage => COMPTETAGE, MONTE => MONTE, DESCEND => DESCEND, ARRET => ARRETOUVRE);
CMPTETG: COMPTEURETAGE port map (MONTE => MONTE, DESCEND => DESCEND, Capteur => Capteur,
CODEETAGE => COMPTETAGE);
AFFICH: SeptSegments port map (a => a, b => b, c => c, d => d, e => e, f => f, g => g,
H0 => COMPTETAGE(2), H1 => COMPTETAGE(1), H2 => COMPTETAGE(0));
TEMPORIS1: Temporisation port map (Validation => ARRETOUVRE, Horl => Horl, InitCompt => 10,
Qsor => FERME);
end architecture FonctionLogique;